#!/bin/bash
# Author: Alan J. Pippin
-# Description: This script will attempt to scrub each zfs pool
-# given to it in the for loop. This script ensures
-# That only 1 scrub operation is running at any given time.
-# This serializes the zfs scrub process for each pool.
+# Description: This script will attempt to scrub a given pool.
+# This script ensures that only 1 scrub operation is
+# running at any given time. This serializes the zfs
+# scrub process for any pool.
-PATH=/usr/sbin:/sbin:$PATH
+PATH=/usr/sbin:/sbin:/etc/bin:$PATH
-pools="tank storage"
+pools="$*"
maxsleeptime=360
-logfile=/var/log/zfs/zfs-scrub.log
+mailto=root
+
+if [ -z "$pools" ]; then
+ echo "-E- Usage: $0 <pools>"
+ exit 1
+fi
for i in $pools
do
- # Check to see if this zfs filesystem has a scrub being performed on it now.
+ # Check to see if any zfs filesystem has a scrub being performed on it now.
# If it does, we cannot perform more than one scrub operation at a time.
while true; do
zpool status | grep scrub: | grep "in progress" > /dev/null 2>&1
done
date=`date`
- echo "$date: Scrub started for zfs pool $i" >> $logfile
+ echo "$date: Scrub started for zfs pool $i"
+ zpool import $i
zpool scrub $i
- sleep 60
+
+ # Wait until the scrub completes, and check for any errors
+ while true; do
+ zpool status $i | grep scrub: | grep "in progress" > /dev/null 2>&1
+ if [ $? == 0 ]; then
+ # Our zpool scrub operation is still running
+ # Wait until it is done before continuing
+ ransleep=$(($RANDOM % $maxsleeptime))
+ sleep $ransleep
+ else
+ # Our scrub operation has completed
+ break
+ fi
+ done
+
+ date=`date`
+ echo "$date: Scrub completed for zfs pool $i"
+
+ # Check for any scrub errors
+ zpool status $i | grep scrub: | grep "with 0 errors" > /dev/null 2>&1
+ if [ $? != 0 ]; then
+ # The scrub found errors
+ zpool status $i | /usr/bin/mailx -s "zpool scrub $i found errors" $mailto
+ fi
done
+
+++ /dev/null
-#!/bin/bash
-
-# Author: Alan J. Pippin
-# Description: This script will attempt to scrub a given EXT drive
-# This script ensures that only 1 scrub operation is
-# running at any given time. This serializes the zfs
-# scrub process for any pool.
-
-PATH=/usr/sbin:/sbin:/etc/bin:$PATH
-
-pools="backups"
-maxsleeptime=360
-mailto=root
-logfile=/var/log/zfs/zfs-scrub.log
-
-for i in $pools
-do
- # Check to see if any zfs filesystem has a scrub being performed on it now.
- # If it does, we cannot perform more than one scrub operation at a time.
- while true; do
- zpool status | grep scrub: | grep "in progress" > /dev/null 2>&1
- if [ $? == 0 ]; then
- # Another zpool scrub operation is already running
- # Wait until it is done before continuing
- ransleep=$(($RANDOM % $maxsleeptime))
- sleep $ransleep
- else
- # Another zpool scrub operation is not running
- break
- fi
- done
-
- date=`date`
- echo "$date: Scrub started for zfs pool $i" >> $logfile
- ext-drive-power on >> /dev/null
- zpool import $i
- zpool scrub $i
-
- # Wait until the scrub completes, and check for any errors
- while true; do
- zpool status $i | grep scrub: | grep "in progress" > /dev/null 2>&1
- if [ $? == 0 ]; then
- # Our zpool scrub operation is still running
- # Wait until it is done before continuing
- ransleep=$(($RANDOM % $maxsleeptime))
- sleep $ransleep
- else
- # Our scrub operation has completed
- break
- fi
- done
-
- date=`date`
- echo "$date: Scrub completed for zfs pool $i" >> $logfile
-
- # Check for any scrub errors
- zpool status $i | grep scrub: | grep "with 0 errors" > /dev/null 2>&1
- if [ $? != 0 ]; then
- # The scrub found errors
- zpool status $i | /usr/bin/mailx -s "zpool scrub $i found errors" $mailto
- fi
-
- # Power off the EXT drive
- zpool export $i
- ext-drive-power off >> /dev/null
-
-done
-